]> git.saurik.com Git - apt.git/blame - test/integration/framework
merged from lp:~donkult/apt/sid
[apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
682a3bf7
DK
4if expr match "$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev/null && \
5 expr match "$(readlink -f /proc/$$/fd/2)" '/dev/pts/[0-9]\+' > /dev/null; then
6 CERROR="\e[1;31m" # red
7 CWARNING="\e[1;33m" # yellow
8 CMSG="\e[1;32m" # green
9 CINFO="\e[1;96m" # light blue
10 CDEBUG="\e[1;94m" # blue
11 CNORMAL="\e[0;39m" # default system console color
12 CDONE="\e[1;32m" # green
13 CPASS="\e[1;32m" # green
14 CFAIL="\e[1;31m" # red
15 CCMD="\e[1;35m" # pink
16fi
8d876415
DK
17
18msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
19msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
20msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
21msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
22msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
23msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
24msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
25msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
26msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
27msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
28msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
29msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
30msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
31msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
32
33# enable / disable Debugging
fc89263e
DK
34MSGLEVEL=${MSGLEVEL:-3}
35if [ $MSGLEVEL -le 0 ]; then
36 msgdie() { true; }
37fi
38if [ $MSGLEVEL -le 1 ]; then
39 msgwarn() { true; }
40 msgnwarn() { true; }
41fi
42if [ $MSGLEVEL -le 2 ]; then
43 msgmsg() { true; }
44 msgnmsg() { true; }
39cc8228
DK
45 msgtest() { true; }
46 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
47 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
682a3bf7
DK
48 if [ -n "$CFAIL" ]; then
49 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
50 else
51 msgfail() { echo -n " ###FAILED###" >&2; }
52 fi
fc89263e
DK
53fi
54if [ $MSGLEVEL -le 3 ]; then
55 msginfo() { true; }
56 msgninfo() { true; }
57fi
58if [ $MSGLEVEL -le 4 ]; then
59 msgdebug() { true; }
60 msgndebug() { true; }
61fi
62msgdone() {
63 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
64 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
65 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
66 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
67 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
68 true;
69 else
70 echo "${CDONE}DONE${CNORMAL}" >&2;
71 fi
72}
8d876415
DK
73
74runapt() {
75 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
7d0627b6
DK
76 if [ -f ./aptconfig.conf ]; then
77 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
4b2a4ab8
MV
78 elif [ -f ../aptconfig.conf ]; then
79 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
7d0627b6
DK
80 else
81 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
82 fi
8d876415
DK
83}
84aptconfig() { runapt apt-config $*; }
85aptcache() { runapt apt-cache $*; }
86aptget() { runapt apt-get $*; }
87aptftparchive() { runapt apt-ftparchive $*; }
1f8b2599 88aptkey() { runapt apt-key $*; }
ec7f904e 89aptmark() { runapt apt-mark $*; }
158fda31
DK
90dpkg() {
91 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
92}
b6b5a542
DK
93aptitude() {
94 if [ -f ./aptconfig.conf ]; then
95 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
96 elif [ -f ../aptconfig.conf ]; then
97 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
98 else
99 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
100 fi
101}
8d876415 102
b720d0bd
DK
103addtrap() {
104 CURRENTTRAP="$CURRENTTRAP $1"
105 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
106}
8d876415
DK
107
108setupenvironment() {
75954ae2 109 TMPWORKINGDIRECTORY=$(mktemp -d)
8f8169ac 110 local TESTDIR=$(readlink -f $(dirname $0))
3cbbda3c 111 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
8f8169ac 112 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
8d876415
DK
113 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
114 local OLDWORKINGDIRECTORY=$(pwd)
b720d0bd 115 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
8d876415 116 cd $TMPWORKINGDIRECTORY
cd725954 117 mkdir rootdir aptarchive keys
8d876415 118 cd rootdir
b29c3712
DK
119 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
120 mkdir -p var/cache var/lib var/log
cffea9af 121 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
2c6baa5a 122 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
8f8169ac
DK
123 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
124 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
125 else
126 touch var/lib/dpkg/status
127 fi
cd725954 128 touch var/lib/dpkg/available
8d876415
DK
129 mkdir -p usr/lib/apt
130 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
131 cd ..
2c6baa5a 132 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
8f8169ac
DK
133 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
134 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 135 fi
4a4ea26c
AM
136 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
137 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
138 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 139 fi
cd725954
DK
140 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
141 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 142 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 143 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
144 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
145 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
f425d4d5 146 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af
DK
147 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
148 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
149 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
150 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
151 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
152 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 153 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
8d876415 154 export LC_ALL=C
7f52cf7b 155 export PATH="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
8d876415
DK
156 msgdone "info"
157}
158
159configarchitecture() {
160 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
234675b7 161 rm -f $CONFFILE
8d876415
DK
162 echo "APT::Architecture \"$1\";" > $CONFFILE
163 shift
164 while [ -n "$1" ]; do
165 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
166 shift
167 done
168}
169
75954ae2 170setupsimplenativepackage() {
ce9864a8
DK
171 local NAME="$1"
172 local ARCH="$2"
173 local VERSION="$3"
174 local RELEASE="${4:-unstable}"
175 local DEPENDENCIES="$5"
176 local DESCRIPTION="$6"
b7899b00
DK
177 local SECTION="${7:-others}"
178 local DISTSECTION
179 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
180 DISTSECTION="main"
181 else
182 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
183 fi
ce9864a8
DK
184 local BUILDDIR=incoming/${NAME}-${VERSION}
185 mkdir -p ${BUILDDIR}/debian/source
186 cd ${BUILDDIR}
187 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
188 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
189 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
190
191 * Initial release
192
b7899b00
DK
193 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
194 test -e debian/control || echo "Source: $NAME
195Section: $SECTION
ce9864a8
DK
196Priority: optional
197Maintainer: Joe Sixpack <joe@example.org>
198Build-Depends: debhelper (>= 7)
199Standards-Version: 3.9.1
200
875bcb36
DK
201Package: $NAME" > debian/control
202 if [ "$ARCH" = 'all' ]; then
203 echo "Architecture: all" >> debian/control
204 else
205 echo "Architecture: any" >> debian/control
206 fi
ce9864a8
DK
207 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
208 if [ -z "$DESCRIPTION" ]; then
209 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
210 If you find such a package installed on your system,
211 YOU did something horribly wrong! They are autogenerated
212 und used only by testcases for APT and surf no other propose…" >> debian/control
213 else
214 echo "Description: $DESCRIPTION" >> debian/control
215 fi
b7899b00
DK
216 test -e debian/compat || echo "7" > debian/compat
217 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 218 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
219 cd - > /dev/null
220}
221
222buildsimplenativepackage() {
223 local NAME="$1"
224 local ARCH="$2"
225 local VERSION="$3"
226 local RELEASE="${4:-unstable}"
227 local DEPENDENCIES="$5"
228 local DESCRIPTION="$6"
229 local SECTION="${7:-others}"
d67004e0 230 local PRIORITY="${8:-optional}"
75954ae2
DK
231 local DISTSECTION
232 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
233 DISTSECTION="main"
234 else
235 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
236 fi
5a635ee4 237 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
b761356f 238
18331adf 239 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
b761356f
DK
240 mkdir -p $BUILDDIR/debian/source
241 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
242 echo "#!/bin/sh
243echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
244
245 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
246 echo "$NAME ($VERSION) $RELEASE; urgency=low
247
248 * Initial release
249
250 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
251 echo "Source: $NAME
252Section: $SECTION
d67004e0 253Priority: $PRIORITY
b761356f
DK
254Maintainer: Joe Sixpack <joe@example.org>
255Standards-Version: 3.9.1
256
875bcb36
DK
257Package: $NAME" > ${BUILDDIR}/debian/control
258 if [ "$ARCH" = 'all' ]; then
259 echo "Architecture: all" >> ${BUILDDIR}/debian/control
260 else
261 echo "Architecture: any" >> ${BUILDDIR}/debian/control
262 fi
b761356f
DK
263 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
264 if [ -z "$DESCRIPTION" ]; then
265 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
266 If you find such a package installed on your system,
267 YOU did something horribly wrong! They are autogenerated
268 und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
269 else
270 echo "Description: $DESCRIPTION" >> ${BUILDIR}/debian/control
271 fi
272 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
273 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
b761356f 274 for SRC in $SRCS; do
5a635ee4 275 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
b761356f 276 done
84aa13f4
DK
277
278 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
279 rm -rf ${BUILDDIR}/debian/tmp
280 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
281 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
282 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
283 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
284 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
285
286 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
287 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
288 done
289
13845042
DK
290 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
291 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
292 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
5a635ee4 293 rm -rf "${BUILDDIR}"
b761356f 294 msgdone "info"
75954ae2
DK
295}
296
297buildpackage() {
298 local BUILDDIR=$1
299 local RELEASE=$2
300 local SECTION=$3
301 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
302 cd $BUILDDIR
303 if [ "$ARCH" = "all" ]; then
304 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
305 fi
b7899b00
DK
306 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
307 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
5ed56f93 308 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 309 cd - > /dev/null
b7899b00 310 for PKG in $PKGS; do
75954ae2 311 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
312 done
313 for SRC in $SRCS; do
75954ae2 314 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 315 done
cffea9af 316 msgdone "info"
ce9864a8
DK
317}
318
319buildaptarchive() {
ce9864a8
DK
320 if [ -d incoming ]; then
321 buildaptarchivefromincoming $*
322 else
323 buildaptarchivefromfiles $*
324 fi
325}
326
327createaptftparchiveconfig() {
328 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
329 if [ -z "$ARCHS" ]; then
330 # the pool is empty, so we will operate on faked packages - let us use the configured archs
331 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
332 fi
ce9864a8
DK
333 echo -n 'Dir {
334 ArchiveDir "' >> ftparchive.conf
335 echo -n $(readlink -f .) >> ftparchive.conf
336 echo -n '";
337 CacheDir "' >> ftparchive.conf
338 echo -n $(readlink -f ..) >> ftparchive.conf
339 echo -n '";
b7899b00
DK
340 FileListDir "' >> ftparchive.conf
341 echo -n $(readlink -f pool/) >> ftparchive.conf
342 echo -n '";
343};
344Default {
bc33e0f0
DK
345 Packages::Compress ". gzip bzip2 lzma xz";
346 Sources::Compress ". gzip bzip2 lzma xz";
347 Contents::Compress ". gzip bzip2 lzma xz";
b7080ced 348 Translation::Compress ". gzip bzip2 lzma xz";
18331adf 349 LongDescription "false";
ce9864a8
DK
350};
351TreeDefault {
352 Directory "pool/";
353 SrcDirectory "pool/";
354};
355APT {
356 FTPArchive {
357 Release {
358 Origin "joesixpack";
359 Label "apttestcases";
360 Suite "unstable";
361 Description "repository with dummy packages";
362 Architectures "' >> ftparchive.conf
363 echo -n "$ARCHS" >> ftparchive.conf
364 echo 'source";
365 };
366 };
367};' >> ftparchive.conf
b7899b00
DK
368 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
369 echo -n 'tree "dists/' >> ftparchive.conf
370 echo -n "$DIST" >> ftparchive.conf
371 echo -n '" {
ce9864a8
DK
372 Architectures "' >> ftparchive.conf
373 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
374 echo -n 'source";
375 FileList "' >> ftparchive.conf
376 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
377 echo -n '";
378 SourceFileList "' >> ftparchive.conf
379 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
380 echo -n '";
381 Sections "' >> ftparchive.conf
382 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
383 echo '";
ce9864a8 384};' >> ftparchive.conf
b7899b00 385 done
ce9864a8
DK
386}
387
388buildaptftparchivedirectorystructure() {
b7899b00
DK
389 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
390 for DIST in $DISTS; do
391 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
392 for SECTION in $SECTIONS; do
393 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
394 for ARCH in $ARCHS; do
395 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
396 done
397 mkdir -p dists/${DIST}/${SECTION}/source
398 mkdir -p dists/${DIST}/${SECTION}/i18n
399 done
ce9864a8 400 done
ce9864a8
DK
401}
402
9b78cda6
DK
403insertpackage() {
404 local RELEASE="$1"
405 local NAME="$2"
406 local ARCH="$3"
407 local VERSION="$4"
408 local DEPENDENCIES="$5"
d67004e0
DK
409 local PRIORITY="${6:-optional}"
410 local ARCHS=""
411 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
412 if [ "$arch" = "all" ]; then
413 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
414 else
415 ARCHS="$arch"
416 fi
417 for BUILDARCH in $ARCHS; do
418 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
419 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
420 touch aptarchive/dists/${RELEASE}/main/source/Sources
421 local FILE="${PPATH}/Packages"
422 echo "Package: $NAME
423Priority: $PRIORITY
9b78cda6 424Section: other
2c085486 425Installed-Size: 42
9b78cda6 426Maintainer: Joe Sixpack <joe@example.org>
d67004e0 427Architecture: $arch
2c085486 428Version: $VERSION
d67004e0
DK
429Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
430 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
431 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
9b78cda6
DK
432 If you find such a package installed on your system,
433 YOU did something horribly wrong! They are autogenerated
434 und used only by testcases for APT and surf no other propose…
435" >> $FILE
d67004e0 436 done
9b78cda6
DK
437 done
438}
439
234675b7
DK
440insertsource() {
441 local RELEASE="$1"
442 local NAME="$2"
443 local ARCH="$3"
444 local VERSION="$4"
445 local DEPENDENCIES="$5"
446 local ARCHS=""
447 local SPATH="aptarchive/dists/${RELEASE}/main/source"
448 mkdir -p $SPATH
449 local FILE="${SPATH}/Sources"
450 echo "Package: $NAME
451Binary: $NAME
452Version: $VERSION
453Maintainer: Joe Sixpack <joe@example.org>
454Architecture: $ARCH" >> $FILE
455 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
456 echo "Files:
457 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
458 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz" >> $FILE
459}
460
dfc2b1be
DK
461insertinstalledpackage() {
462 local NAME="$1"
463 local ARCH="$2"
464 local VERSION="$3"
465 local DEPENDENCIES="$4"
d67004e0 466 local PRIORITY="${5:-optional}"
dfc2b1be 467 local FILE="rootdir/var/lib/dpkg/status"
d67004e0
DK
468 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
469 echo "Package: $NAME
dfc2b1be 470Status: install ok installed
d67004e0 471Priority: $PRIORITY
dfc2b1be
DK
472Section: other
473Installed-Size: 42
474Maintainer: Joe Sixpack <joe@example.org>
d67004e0 475Architecture: $arch
dfc2b1be 476Version: $VERSION" >> $FILE
d67004e0
DK
477 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
478 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
dfc2b1be
DK
479 If you find such a package installed on your system,
480 YOU did something horribly wrong! They are autogenerated
481 und used only by testcases for APT and surf no other propose…
482" >> $FILE
d67004e0 483 done
dfc2b1be
DK
484}
485
486
ce9864a8 487buildaptarchivefromincoming() {
3cbbda3c 488 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
489 cd aptarchive
490 [ -e pool ] || ln -s ../incoming pool
491 [ -e ftparchive.conf ] || createaptftparchiveconfig
492 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 493 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 494 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
495 cd - > /dev/null
496 msgdone "info"
9b78cda6 497 generatereleasefiles
ce9864a8
DK
498}
499
500buildaptarchivefromfiles() {
3cbbda3c 501 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
502 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
503 msgninfo "\t${line} file… "
504 cat ${line} | gzip > ${line}.gz
505 cat ${line} | bzip2 > ${line}.bz2
506 cat ${line} | lzma > ${line}.lzma
b7080ced 507 cat ${line} | xz > ${line}.xz
8d876415 508 msgdone "info"
9b78cda6
DK
509 done
510 generatereleasefiles
511}
512
a3bbbab7
DK
513# can be overridden by testcases for their pleasure
514getcodenamefromsuite() { echo -n "$1"; }
515getreleaseversionfromsuite() { true; }
718f797c 516getlabelfromsuite() { true; }
a3bbbab7 517
9b78cda6 518generatereleasefiles() {
884a4c0a
DK
519 # $1 is the Date header and $2 is the ValidUntil header to be set
520 # both should be given in notation date/touch can understand
9b78cda6
DK
521 msgninfo "\tGenerate Release files… "
522 if [ -e aptarchive/dists ]; then
18331adf
DK
523 for dir in $(find ./aptarchive/dists -mindepth 3 -maxdepth 3 -type d -name 'i18n'); do
524 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Patterns::='Translation-*' > $dir/Index
525 done
9b78cda6 526 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
a3bbbab7
DK
527 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
528 local CODENAME="$(getcodenamefromsuite $SUITE)"
529 local VERSION="$(getreleaseversionfromsuite $SUITE)"
718f797c 530 local LABEL="$(getlabelfromsuite $SUITE)"
884a4c0a 531 if [ -n "$VERSION" ]; then
718f797c
DK
532 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
533 fi
534 if [ -n "$LABEL" ]; then
535 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
a3bbbab7 536 fi
884a4c0a
DK
537 aptftparchive -qq release $dir \
538 -o APT::FTPArchive::Release::Suite="${SUITE}" \
539 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
718f797c 540 ${LABEL} \
884a4c0a
DK
541 ${VERSION} \
542 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
a3bbbab7 543 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
35faae11
DK
544 sed -i '/^Date: / a\
545NotAutomatic: yes' $dir/Release
546 fi
884a4c0a
DK
547 if [ -n "$1" -a "$1" != "now" ]; then
548 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
549 fi
550 if [ -n "$2" ]; then
551 sed -i "/^Date: / a\
552Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
553 fi
9b78cda6
DK
554 done
555 else
556 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 557 fi
884a4c0a 558 if [ -n "$1" -a "$1" != "now" ]; then
fe0f7911
DK
559 for release in $(find ./aptarchive -name 'Release'); do
560 touch -d "$1" $release
561 done
8d876415 562 fi
b7899b00 563 msgdone "info"
8d876415
DK
564}
565
b7899b00
DK
566setupdistsaptarchive() {
567 local APTARCHIVE=$(readlink -f ./aptarchive)
568 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
569 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
570 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
571 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
572 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
573 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
574 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
575 msgdone "info"
576 done
577}
578
579setupflataptarchive() {
ce9864a8 580 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
581 if [ -f ${APTARCHIVE}/Packages ]; then
582 msgninfo "\tadd deb sources.list line… "
583 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
584 msgdone "info"
585 else
586 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
587 fi
588 if [ -f ${APTARCHIVE}/Sources ]; then
589 msgninfo "\tadd deb-src sources.list line… "
590 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
591 msgdone "info"
592 else
593 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
594 fi
b7899b00
DK
595}
596
597setupaptarchive() {
598 buildaptarchive
599 if [ -e aptarchive/dists ]; then
600 setupdistsaptarchive
601 else
602 setupflataptarchive
603 fi
f213b6ea 604 signreleasefiles
cd725954 605 msgninfo "\tSync APT's cache with the archive… "
8d876415 606 aptget update -qq
cd725954 607 msgdone "info"
8d876415
DK
608}
609
f213b6ea
DK
610signreleasefiles() {
611 local SIGNER="${1:-Joe Sixpack}"
612 msgninfo "\tSign archive with $SIGNER key… "
613 local SECKEYS=""
614 for KEY in $(find keys/ -name '*.sec'); do
615 SECKEYS="$SECKEYS --secret-keyring $KEY"
616 done
617 local PUBKEYS=""
618 for KEY in $(find keys/ -name '*.pub'); do
619 PUBKEYS="$PUBKEYS --keyring $KEY"
620 done
621 for RELEASE in $(find aptarchive/ -name Release); do
622 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
fe0f7911 623 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
f213b6ea
DK
624 done
625 msgdone "info"
626}
627
628changetowebserver() {
629 if which weborf > /dev/null; then
630 weborf -xb aptarchive/ 2>&1 > /dev/null &
b720d0bd 631 addtrap "kill $!;"
6e7d39d0
DK
632 elif which gatling > /dev/null; then
633 cd aptarchive
634 gatling -p 8080 -F -S 2>&1 > /dev/null &
635 addtrap "kill $!;"
636 cd - > /dev/null
c5bcc607
DK
637 elif which lighttpd > /dev/null; then
638 echo "server.document-root = \"$(readlink -f ./aptarchive)\"
639server.port = 8080
640server.stat-cache-engine = \"disable\"" > lighttpd.conf
641 lighttpd -t -f lighttpd.conf >/dev/null || msgdie 'Can not change to webserver: our lighttpd config is invalid'
642 lighttpd -D -f lighttpd.conf 2>/dev/null >/dev/null &
643 addtrap "kill $!;"
644 else
645 msgdie 'You have to install weborf or lighttpd first'
646 return 1
f213b6ea 647 fi
c5bcc607
DK
648 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
649 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
650 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
651 done
652 return 0
f213b6ea
DK
653}
654
655checkdiff() {
8d876415
DK
656 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
657 if [ -n "$DIFFTEXT" ]; then
658 echo
659 echo "$DIFFTEXT"
660 return 1
661 else
662 return 0
663 fi
664}
665
75954ae2
DK
666testfileequal() {
667 local FILE="$1"
668 shift
669 msgtest "Test for correctness of file" "$FILE"
670 if [ -z "$*" ]; then
f213b6ea 671 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 672 else
f213b6ea 673 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
674 fi
675}
676
8d876415
DK
677testequal() {
678 local COMPAREFILE=$(mktemp)
b720d0bd 679 addtrap "rm $COMPAREFILE;"
8d876415
DK
680 echo "$1" > $COMPAREFILE
681 shift
682 msgtest "Test for equality of" "$*"
f213b6ea 683 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
684}
685
685625bd
DK
686testequalor2() {
687 local COMPAREFILE1=$(mktemp)
688 local COMPAREFILE2=$(mktemp)
689 local COMPAREAGAINST=$(mktemp)
b720d0bd 690 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
685625bd
DK
691 echo "$1" > $COMPAREFILE1
692 echo "$2" > $COMPAREFILE2
693 shift 2
694 msgtest "Test for equality OR of" "$*"
695 $* 2>&1 1> $COMPAREAGAINST
f213b6ea
DK
696 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
697 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
698 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
699 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
685625bd
DK
700 msgfail )
701}
702
8d876415 703testshowvirtual() {
edc0ef10 704 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
705 local PACKAGE="$1"
706 shift
707 while [ -n "$1" ]; do
708 VIRTUAL="${VIRTUAL}
edc0ef10 709N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
710 PACKAGE="${PACKAGE} $1"
711 shift
712 done
713 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
714 VIRTUAL="${VIRTUAL}
4bec02c2 715N: No packages found"
8d876415 716 local COMPAREFILE=$(mktemp)
b720d0bd 717 addtrap "rm $COMPAREFILE;"
8d876415
DK
718 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
719 eval `apt-config shell ARCH APT::Architecture`
720 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 721 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
722}
723
724testnopackage() {
725 msgtest "Test for non-existent packages" "apt-cache show $*"
726 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
727 if [ -n "$SHOWPKG" ]; then
728 echo
729 echo "$SHOWPKG"
730 msgfail
731 return 1
732 fi
733 msgpass
734}
01a6e24c
DK
735
736testdpkginstalled() {
737 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
87bc1c45
DK
738 local PKGS="$(dpkg -l $* | grep '^i' | wc -l)"
739 if [ "$PKGS" != $# ]; then
01a6e24c
DK
740 echo $PKGS
741 dpkg -l $* | grep '^[a-z]'
742 msgfail
743 return 1
744 fi
745 msgpass
746}
747
5cf733e1
DK
748testdpkgnotinstalled() {
749 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
87bc1c45 750 local PKGS="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
01a6e24c
DK
751 if [ "$PKGS" != 0 ]; then
752 echo
753 dpkg -l $* | grep '^[a-z]'
754 msgfail
755 return 1
756 fi
757 msgpass
758}
ec7f904e
DK
759
760testmarkedauto() {
761 local COMPAREFILE=$(mktemp)
762 addtrap "rm $COMPAREFILE;"
763 if [ -n "$1" ]; then
764 msgtest 'Test for correctly marked as auto-installed' "$*"
765 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
766 else
767 msgtest 'Test for correctly marked as auto-installed' 'no package'
c98fb5e0 768 echo -n > $COMPAREFILE
ec7f904e
DK
769 fi
770 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
771}
89a1aa5d
DK
772
773pause() {
774 echo "STOPPED execution. Press enter to continue"
775 local IGNORE
776 read IGNORE
777}